using UnityEngine;

public class GameManager : MonoBehaviour
{
    private GameSystem _gameSystem;
    private void Awake()
    {
        _gameSystem = new GameSystem(Contexts.sharedInstance);
    }

    private void Start()
    {
        var playerEntity = Contexts.sharedInstance.game.CreateEntity();
        playerEntity.isPlayerTag = true;
        playerEntity.AddPosComp(Vector2.zero);
        playerEntity.AddVelComp(Vector2.zero);
        playerEntity.AddCreatObjectCmdComp("Prefab/Player");

        _gameSystem.Initialize();
    }

    private void Update()
    {
        _gameSystem.Execute();
        _gameSystem.Cleanup();
    }

    private void OnDestroy()
    {
        _gameSystem.TearDown();
    }
}
