using UnityEngine;
using Entitas;

public class MoveSystem : IExecuteSystem
{
    private readonly IGroup<GameEntity> _group;

    public MoveSystem(Contexts contexts)
    {
        _group = contexts.game.GetGroup(GameMatcher.AllOf(
            GameMatcher.PosComp,
            GameMatcher.VelComp,
            GameMatcher.ViewComp
            ));
    }


    public void Execute()
    {
        var dt = Time.deltaTime;
        foreach(var entity in _group.GetEntities())
        {
            var posComp = entity.posComp;
            var velComp = entity.velComp;
            entity.ReplacePosComp(new Vector2(
                posComp.value.x + dt * velComp.value.x,
                posComp.value.y + dt * velComp.value.y
                ));
            entity.viewComp.view.transform.position = entity.posComp.value;
        }
    }
}
